org.apache.commons.math.ode.sampling

## Interface StepInterpolator

All Superinterfaces:
  Externalizable, Serializable

All Known Implementing Classes:
  AbstractStepInterpolator, ClassicalRungeKuttaStepInterpolator, DormandPrince54StepInterpolator, DormandPrince853StepInterpolator, DummyStepInterpolator, EulerStepInterpolator, GillStepInterpolator, GraggBulirschStoerStepInterpolator, HighamHall54StepInterpolator, MidpointStepInterpolator, NordsieckStepInterpolator, RungeKuttaStepInterpolator, ThreeEighthesStepInterpolator

    public interface StepInterpolator
    extends Externalizable

This interface represents an interpolator over the last step during an ODE integration.

The various ODE integrators provide objects implementing this interface to the step handlers. These objects are often custom objects tightly bound to the integrator internal algorithms. The handlers can use these objects to retrieve the state vector at intermediate times between the previous and the current grid points (this feature is often called dense output).

One important thing to note is that the step handlers may be so tightly bound to the integrators that they often share some internal state arrays. This imply that one should never use a direct reference to a step interpolator outside of the step handler, either for future use or for use in another thread. If such a need arise, the step interpolator must be copied using the dedicated `copy()` method.

Since:
  1.2
Version:
  $Revision: 1073158 $ $Date: 2011-02-21 22:46:52 +0100 (lun. 21 févr. 2011) $
See Also:
  `FirstOrderIntegrator`, `SecondOrderIntegrator`, `StepHandler`

### Method Summary

Methods
`StepInterpolator` `copy()` Copy the instance.
`double` `getCurrentTime()` Get the current grid point time.
`double[]` `getInterpolatedDerivatives()` Get the derivatives of the state vector of the interpolated point.
`double[]` `getInterpolatedState()` Get the state vector of the interpolated point.
`double` `getInterpolatedTime()` Get the time of the interpolated point.
`double` `getPreviousTime()` Get the previous grid point time.
`boolean` `isForward()` Check if the natural integration direction is forward.
`void` `setInterpolatedTime(double time)` Set the time of the interpolated point.

### Methods inherited from interface java.io.Externalizable

`readExternal, writeExternal`

### Method Detail

#### getPreviousTime

    double getPreviousTime()

Get the previous grid point time.

Returns:
  previous grid point time

#### getCurrentTime

    double getCurrentTime()

Get the current grid point time.

Returns:
  current grid point time

#### getInterpolatedTime

    double getInterpolatedTime()

Get the time of the interpolated point. If `setInterpolatedTime(double)` has not been called, it returns the current grid point time.

Returns:
  interpolation point time

#### setInterpolatedTime

    void setInterpolatedTime(double time)

Set the time of the interpolated point.

Setting the time outside of the current step is now allowed, but should be used with care since the accuracy of the interpolator will probably be very poor far from this step. This allowance has been added to simplify implementation of search algorithms near the step endpoints.

Setting the time changes the instance internal state. If a specific state must be preserved, a copy of the instance must be created using `copy()`.

Parameters:
  `time` - time of the interpolated point

#### getInterpolatedState

    double[] getInterpolatedState()
                                  throws DerivativeException

Get the state vector of the interpolated point.

The returned vector is a reference to a reused array, so it should not be modified and it should be copied if it needs to be preserved across several calls.

Returns:
  state vector at time `getInterpolatedTime()`
Throws:
  `DerivativeException` - if user code called from step interpolator finalization triggers one
See Also:
  `getInterpolatedDerivatives()`

#### getInterpolatedDerivatives

    double[] getInterpolatedDerivatives()
                                        throws DerivativeException

Get the derivatives of the state vector of the interpolated point.

The returned vector is a reference to a reused array, so it should not be modified and it should be copied if it needs to be preserved across several calls.

Returns:
  derivatives of the state vector at time `getInterpolatedTime()`
Throws:
  `DerivativeException` - if user code called from step interpolator finalization triggers one
Since:
  2.0
See Also:
  `getInterpolatedState()`

#### isForward

    boolean isForward()

Check if the natural integration direction is forward.

This method provides the integration direction as specified by the integrator itself, it avoid some nasty problems in degenerated cases like null steps due to cancellation at step initialization, step control or discrete events triggering.

Returns:
  true if the integration variable (time) increases during integration

#### copy

    StepInterpolator copy()
                          throws DerivativeException

Copy the instance.

The copied instance is guaranteed to be independent from the original one. Both can be used with different settings for interpolated time without any side effect.

Returns:
  a deep copy of the instance, which can be used independently.
Throws:
  `DerivativeException` - if user code called from step interpolator finalization triggers one
See Also:
  `setInterpolatedTime(double)`